VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Registry sample by Matt Hart - vbhelp@matthart.com"
   ClientHeight    =   4125
   ClientLeft      =   930
   ClientTop       =   855
   ClientWidth     =   5850
   Height          =   4530
   Left            =   870
   LinkTopic       =   "Form1"
   ScaleHeight     =   4125
   ScaleWidth      =   5850
   Top             =   510
   Width           =   5970
   Begin VB.ListBox List1 
      Height          =   3570
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   5595
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "HKEY_USERS\.Default\RemoteAccess\Addresses"
      Height          =   195
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   5595
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

' Registry Sample by Matt Hart - vbhelp@matthart.com
' http://matthart.com
'
' The commented portion of this sample creates a key, sets a value,
' and retrieves a value.
'
' This sample has been updated to enumerate all the Values of
' the HKEY_USERS\.Default\RemoteAccess key.
'
' Note that I have CHANGED the declaration for RegEnumValue.
' It had one error in the Win32API file:
'      lpReserved As Long
' is supposed to be NULL according to the SDK.  However, declaring
' it like this will cause a POINTER to the value (0) to be passed
' rather than NULL.  I changed it to:
'      ByVal lpReserved As Long
' That will force a value of 0 to be passed rather than a non-zero
' POINTER to the value of 0.
' Also, I changed this:
'      lpData As Any
' to:
'      ByVal lpData As String
' I could have left it As Any.  However, I would then have needed to
' use a fixed length string or a numeric variable.  By passing a
' variable length string buffer, I can easily extract a non-string
' value.  (See the Select Case lType).
'
' See Win32api file for several more Reg???? API calls.
' This is the Microsoft KB article, but I fixed the bugs in it.

Private Type a4
    a As String * 4
End Type
Private Type l4
    l As Long
End Type

Private Sub Form_Load()
'    CreateNewKey "TestKey\SubKey1\SubKey2", HKEY_LOCAL_MACHINE
'    SetKeyValue "TestKey\SubKey1", "StringValue", "Hello", REG_SZ
'    QueryValue "TestKey\SubKey1", "StringValue"

    Dim lRet As Long, hKey As Long
    lRet = RegOpenKeyEx(HKEY_USERS, ".Default\RemoteAccess", 0, KEY_ALL_ACCESS, hKey)
    If lRet Then MsgBox "Error accessing HKEY_USERS\.Default\RemoteAccess": Exit Sub
    
    Dim lIndex As Long, aVName$, lVName As Long, lType As Long, aData$, lData As Long
    Dim aAdd$, l As Long, a4 As a4, l4 As l4, a$
    lVName = 100                ' Name buffer length
    aVName$ = Space$(lVName)    ' Name buffer
    lData = 100                 ' Data buffer length
    aData$ = Space$(lData)      ' Data buffer
    lRet = RegEnumValue(hKey, lIndex, aVName$, lVName, 0, lType, aData$, lData)
    Do Until lRet = ERROR_NO_MORE_ITEMS
        aAdd$ = Left$(aVName$, lVName) & vbTab  ' Note that lVName returns the # of bytes copied
        Do Until TextWidth(aAdd$) > List1.Width \ 4: aAdd$ = aAdd$ & " ": Loop
        aAdd$ = aAdd$ & vbTab
        Select Case lType
            Case REG_BINARY
                For l = 1 To lData
                    a$ = Hex$(Asc(Mid$(aData$, l, 1)))
                    If Len(a$) = 1 Then a$ = "0" & a$
                    aAdd$ = aAdd$ & a$ & " "
                Next
            Case REG_DWORD
                a4.a = Left$(aData$, lData)
                LSet l4 = a4
                aAdd$ = aAdd$ & l4.l
            Case Else       ' String or other
                aAdd$ = aAdd$ & Left$(aData$, lData)    ' Note that lData returns the # of bytes copied
        End Select
        List1.AddItem aAdd$
        lVName = 100        ' You MUST reset these buffer lengths, because the RegEnumValue call
        lData = 100         ' changed them to = # of bytes copied
        lIndex = lIndex + 1
        lRet = RegEnumValue(hKey, lIndex, aVName$, lVName, 0, lType, aData$, lData)
    Loop
        
    lRet = RegCloseKey(hKey)
End Sub


